#include <iostream>
#include <math.h>

using namespace std;

//------------------------------------------------------------------------------

class TEstado{

  public:
  	TEstado( int mi, int ca, int ba ) {m = mi; c = ca; b = ba;}
  	TEstado() {m = -1; c = -1; b = -1;}

	//retorna o nmero de missionrios
	int getMissionario() { return m; }
        //retorna o nmero de canibais
	int getCanibal() { return c; }
	//retorna se o barco est ou no na margem de incio
    	int getBarco() { return b; }

	//altera o nmero de missionrios
	void setMissionario( int x ) { m = x;}
	void setCanibal( int x ) { c = x;}
	void setBarco( int x ) { b = x;}

	private:
     	//nmero de missonrios na margem de incio
	    int m;
        //nmero de canibais na margem de incio
	    int c;
        //Indica se o barco est na margem de incio
      int b;
};


class TOperadores {

	public:
		//move um canibal para a margem oposta
	    TEstado mover1c( TEstado );
		//move um missionrio para a margem oposta
	    TEstado mover1m( TEstado );
		//move dois canibais para a margem oposta
	    TEstado mover2c( TEstado ) ;
	    //move dois missionrios para a margem oposta
		TEstado mover2m( TEstado );
		//move um canibal e um missionrio para a margem oposta
	    TEstado mover1m1c( TEstado );

};

class TNo {

	public:
    TNo() { nivel = 0; pt_pai = NULL; heuristica = 0;}
    int getNivel() { return nivel; }
	  void setNivel( int x ) { nivel = x; }
    int getHeuristica() { return heuristica; }
	  void setHeuristica( int x ) { heuristica = x; }
	  TNo* getPai() { return pt_pai; }
	  void setPai( TNo *x ) { pt_pai = x; }
	  TEstado getEstado() { return estado; }
	  void setEstado( TEstado x ) { estado = x; }

	private:
	  int nivel;
    int heuristica;
    TNo* pt_pai;
    TEstado estado;
};

//---------------implementao das funes------------------------

//--------------incio da classe operadores------------------------

// No nos preocupamos aqui em gerar estados vlidos //
TEstado TOperadores::mover1c( TEstado e )
{
  if (e.getBarco()) /* Barco na Margem Inicial */
  {
    TEstado novoEstado(e.getMissionario(), e.getCanibal() - 1, (e.getBarco()+ 1) % 2);
    return novoEstado;
  }
  else
  {
    TEstado novoEstado(e.getMissionario(), e.getCanibal() + 1, (e.getBarco()+ 1) % 2);
    return novoEstado;
  }
}

TEstado TOperadores::mover1m( TEstado e )
{
  if (e.getBarco())
  {
	  TEstado novoEstado(e.getMissionario() - 1, e.getCanibal(), (e.getBarco()+ 1) % 2);
    return novoEstado;
  }
  else
  {
    TEstado novoEstado(e.getMissionario() + 1, e.getCanibal(), (e.getBarco()+ 1) % 2);
    return novoEstado;
  }
}

TEstado TOperadores::mover2c( TEstado e )
{
  if (e.getBarco())
  {
	  TEstado novoEstado(e.getMissionario(), e.getCanibal() - 2, (e.getBarco()+ 1) % 2);
    return novoEstado;
  }
  else
  {
    TEstado novoEstado(e.getMissionario(), e.getCanibal() + 2, (e.getBarco()+ 1) % 2);
    return novoEstado;
  }
}

TEstado TOperadores::mover2m( TEstado e )
{
  if (e.getBarco())
  {
	  TEstado novoEstado(e.getMissionario() - 2, e.getCanibal(), (e.getBarco()+ 1) % 2);
    return novoEstado;
  }
  else
  {
    TEstado novoEstado(e.getMissionario() + 2, e.getCanibal(), (e.getBarco()+ 1) % 2);
    return novoEstado;
  }
}

TEstado TOperadores:: mover1m1c( TEstado e )
{
  if (e.getBarco())
  {
	  TEstado novoEstado(e.getMissionario() - 1, e.getCanibal() - 1, (e.getBarco()+ 1) % 2);
    return novoEstado;
  }
  else
  {
    TEstado novoEstado(e.getMissionario() + 1, e.getCanibal() + 1, (e.getBarco()+ 1) % 2);
    return novoEstado;
  }
}

//---------------fim da classe operadores------------------------


