/* Trabalho de IA Grupo: Bruno Kinder
                         Yura C. Ferreira           */


#include "busca.h"
#include <time.h>

void menu()
{
    cout << "Comandos:" << endl;
    cout << "L  - Busca em largura." << endl;
    cout << "P  - Busca em Profundidade." << endl;
    cout << "B  - Busca em Profundidade Limitada. NECESSITA DE UM LIMITE." << endl;
    cout << "I  - Busca em Profundidade Iterativa." << endl;
    cout << "A  - Busca A Estrela." << endl;
    cout << "M  - Este Menu." << endl;
    cout << "S  - Sair." << endl;
    cout << endl << "Digite a Opcao: ";
}
//---------------------------------------------------------------------------
int main()
{
  char tipoBusca;
  int profundidadeLimite;
  bool primeiraVez = true;
  TListaNos visitados;
  clock_t start, end;
  unsigned int memoria_maxima,
      nos_gerados,
      nos_visitados,
      nos_memoria;
  int nivel_maximo;
  unsigned int acum_memoria_maxima=0,
      acum_nos_gerados=0,
      acum_nos_visitados=0,
      acum_memoria_solucao=0;

  for(;;)
  {
    if ( primeiraVez )
    {
      menu();
      primeiraVez = false;
    }

    cin >> tipoBusca;
    tipoBusca = (char) toupper( tipoBusca );

    switch ( tipoBusca )
    {
      case 'L':
        start = clock();
        visitados = busca ( "LARGURA", -1, 3, 3, memoria_maxima, nos_gerados,
                            nos_visitados, nos_memoria, nivel_maximo);
        end = clock();
        cout << endl;
        cout << "------------------------------------------------------- " <<endl;
        cout << "-------------- Resultado Busca em Largura ------------- " <<endl;
        cout << "------------------------------------------------------- " <<endl;
        imprime_resultado(visitados.back());
        cout << endl <<"O tempo de execucao foi              : ";
        cout << (end - start) * 1000 / CLK_TCK << " milisegundos" << endl;
        cout << "Nos Visitados                        : " << nos_visitados << endl;
        cout << "Nos Gerados                          : " << nos_gerados << endl;
        cout << "Num. Max. de Nos em Memoria          : " << memoria_maxima << endl;
        cout << "Num. Nos na Arvore ao Achar a Solucao: " << nos_memoria << endl;
        cout << "Memoria Maxima Utilizada             : ";
        if ( (memoria_maxima*sizeof(TNo)) > 1024)
          cout  << (memoria_maxima*sizeof(TNo))/1024 << " KB" << endl;
        else
          cout << (memoria_maxima*sizeof(TNo)) << " Bytes" << endl;
        cout << "Memoria Utilizada Pela Solucao       : ";
        if ( (nos_memoria*sizeof(TNo)) > 1024)
          cout << (nos_memoria*sizeof(TNo))/1024 << " KB" << endl;
        else
          cout << (nos_memoria*sizeof(TNo)) << " Bytes" << endl;
        cout << "Profundidade da Solucao              : " << visitados.back() -> getNivel();
        cout << endl << "Profundidade Maxima Atingida         : " << nivel_maximo;
        cout << endl;
        cout << endl;
        cout << "------------------------------------------------------- " <<endl;
        cout << endl;
        cout << endl << "Digite a Opcao (S:Sair, M:Menu): ";
        break;

      case 'P':
        start = clock();
        visitados = busca ( "PROFUNDIDADE", -1, 3, 3, memoria_maxima,
                            nos_gerados, nos_visitados, nos_memoria, nivel_maximo);
        end = clock();
        cout << endl;
        cout << "------------------------------------------------------- " <<endl;
        cout << "------------- Resultado Busca Profundidade ------------ " <<endl;
        cout << "------------------------------------------------------- " <<endl;
        imprime_resultado(visitados.front());
        cout << endl <<"O tempo de execucao foi              : ";
        cout << (end - start) * 1000 / CLK_TCK << " milisegundos" << endl;
        cout << "Nos Visitados                        : " << nos_visitados << endl;
        cout << "Nos Gerados                          : " << nos_gerados << endl;
        cout << "Num. Max. de Nos em Memoria          : " << memoria_maxima << endl;
        cout << "Num. Nos na Arvore ao Achar a Solucao: " << nos_memoria << endl;
        cout << "Memoria Maxima Utilizada             : ";
        if ( (memoria_maxima*sizeof(TNo)) > 1024)
          cout  << (memoria_maxima*sizeof(TNo))/1024 << " KB" << endl;
        else
          cout << (memoria_maxima*sizeof(TNo)) << " Bytes" << endl;
        cout << "Memoria Utilizada Pela Solucao       : ";
        if ( (nos_memoria*sizeof(TNo)) > 1024)
          cout << (nos_memoria*sizeof(TNo))/1024 << " KB" << endl;
        else
          cout << (nos_memoria*sizeof(TNo)) << " Bytes" << endl;
        cout << "Profundidade da Solucao              : " << visitados.front() -> getNivel();
        cout << endl << "Profundidade Maxima Atingida         : " << nivel_maximo;
        cout << endl;
        cout << endl;
        cout << "------------------------------------------------------- " <<endl;
        cout << endl;
        cout << endl << "Digite a Opcao (S:Sair, M:Menu): ";
        break;

      case 'A':
        start = clock();
        visitados = AEstrela( 3, 3, memoria_maxima, nos_gerados, nos_visitados,
                              nos_memoria, nivel_maximo);
        end = clock();
        cout << endl;
        cout << "------------------------------------------------------- " <<endl;
        cout << "----------------- Resultado Busca A* ------------------ " <<endl;
        cout << "------------------------------------------------------- " <<endl;
        imprime_resultado(visitados.back());
        cout << endl <<"O tempo de execucao foi              : ";
        cout << (end - start) * 1000 / CLK_TCK << " milisegundos" << endl;
        cout << "Nos Visitados                        : " << nos_visitados << endl;
        cout << "Nos Gerados                          : " << nos_gerados << endl;
        cout << "Num. Max. de Nos em Memoria          : " << memoria_maxima << endl;
        cout << "Num. Nos na Arvore ao Achar a Solucao: " << nos_memoria << endl;
        cout << "Memoria Maxima Utilizada             : ";
        if ( (memoria_maxima*sizeof(TNo)) > 1024)
          cout  << (memoria_maxima*sizeof(TNo))/1024 << " KB" << endl;
        else
          cout << (memoria_maxima*sizeof(TNo)) << " Bytes" << endl;
        cout << "Memoria Utilizada Pela Solucao       : ";
        if ( (nos_memoria*sizeof(TNo)) > 1024)
          cout << (nos_memoria*sizeof(TNo))/1024 << " KB" << endl;
        else
          cout << (nos_memoria*sizeof(TNo)) << " Bytes" << endl;
        cout << "Profundidade da Solucao              : " << visitados.back() -> getNivel();
        cout << endl << "Profundidade Maxima Atingida         : " << nivel_maximo;
        cout << endl;
        cout << endl;
        cout << "------------------------------------------------------- " <<endl;
        cout << endl;
        cout << endl << "Digite a Opcao (S:Sair, M:Menu): ";
        break;

      case 'I':
        profundidadeLimite = 1;
        start = clock();
        do
        {
          visitados = busca ( "PROFUNDIDADE" , profundidadeLimite, 3, 3,
                              memoria_maxima, nos_gerados, nos_visitados,
                              nos_memoria, nivel_maximo);
          if (memoria_maxima > acum_memoria_maxima) acum_memoria_maxima = memoria_maxima;
          if (acum_memoria_solucao < nos_memoria) acum_memoria_solucao = nos_memoria;
          acum_nos_gerados = acum_nos_gerados + nos_gerados;
          acum_nos_visitados = acum_nos_visitados + nos_visitados;
          ++profundidadeLimite;
        } while (!((visitados.front() -> getEstado().getMissionario() == 0) &&
                   (visitados.front() -> getEstado().getCanibal() == 0) &&
                   (visitados.front() -> getEstado().getBarco() == 0)));

        end = clock();
        cout << endl;
        cout << "------------------------------------------------------- " <<endl;
        cout << "-------- Resultado Busca Profundidade Iterativa ------- " <<endl;
        cout << "------------------------------------------------------- " <<endl;
        imprime_resultado(visitados.front());
        cout << endl <<"O tempo de execucao foi              : ";
        cout << (end - start) * 1000 / CLK_TCK << " milisegundos" << endl;
        cout << "Nos Visitados                        : " << acum_nos_visitados << endl;
        cout << "Nos Gerados                          : " << acum_nos_gerados << endl;
        cout << "Num. Max. de Nos em Memoria          : " << memoria_maxima << endl;
        cout << "Num. Nos na Arvore ao Achar a Solucao: " << nos_memoria << endl;
        cout << "Memoria Maxima Utilizada             : ";
        if ( (acum_memoria_maxima*sizeof(TNo)) > 1024)
          cout  << (acum_memoria_maxima*sizeof(TNo))/1024 << " KB" << endl;
        else
          cout << (acum_memoria_maxima*sizeof(TNo)) << " Bytes" << endl;
        cout << "Memoria Utilizada Pela Solucao       : ";
        if ( (acum_memoria_solucao*sizeof(TNo)) > 1024)
          cout << (acum_memoria_solucao*sizeof(TNo))/1024 << " KB" << endl;
        else
          cout << (acum_memoria_solucao*sizeof(TNo)) << " Bytes" << endl;
        cout << "Profundidade da Solucao              : " << visitados.front() -> getNivel();
        cout << endl << "Profundidade Maxima Atingida         : " << nivel_maximo;
        cout << endl;
        cout << endl;
        cout << "------------------------------------------------------- " <<endl;
        cout << endl;
        cout << endl << "Digite a Opcao (S:Sair, M:Menu): ";
        break;

      case 'B':
        cin >> profundidadeLimite;
        start = clock();
        visitados = busca ( "PROFUNDIDADE" , profundidadeLimite, 3, 3 ,
                            memoria_maxima, nos_gerados, nos_visitados,
                            nos_memoria, nivel_maximo);
        end = clock();
        cout << endl;
        cout << "------------------------------------------------------- " <<endl;
        cout << "------- Resultado Busca Limitada Profundidade --------- " <<endl;
        cout << "------------------------------------------------------- " <<endl;
        if ( (visitados.front() -> getEstado().getMissionario() == 0) &&
             (visitados.front() -> getEstado().getCanibal() == 0) &&
             (visitados.front() -> getEstado().getBarco() == 0))
          imprime_resultado(visitados.front());
        else
          cout << "A Profundidade Limite nao foi suficiente para encontrar a solucao!" << endl;
        cout << endl <<"O tempo de execucao foi              : " << (end - start) * 1000 / CLK_TCK << " milisegundos" << endl;
        cout << "Nos Visitados                        : " << nos_visitados << endl;
        cout << "Nos Gerados                          : " << nos_gerados << endl;
        cout << "Num. Max. de Nos em Memoria          : " << memoria_maxima << endl;
        cout << "Num. Nos na Arvore ao Achar a Solucao: " << nos_memoria << endl;
        cout << "Memoria Maxima Utilizada             : ";
        if ( (memoria_maxima*sizeof(TNo)) > 1024)
          cout  << (memoria_maxima*sizeof(TNo))/1024 << " KB" << endl;
        else
          cout << (memoria_maxima*sizeof(TNo)) << " Bytes" << endl;
        cout << "Memoria Utilizada Pela Solucao       : ";
        if ( (nos_memoria*sizeof(TNo)) > 1024)
          cout << (nos_memoria*sizeof(TNo))/1024 << " KB" << endl;
        else
          cout << (nos_memoria*sizeof(TNo)) << " Bytes" << endl;
        cout << "Profundidade da Solucao              : " << visitados.front() -> getNivel();
        cout << endl << "Profundidade Maxima Atingida         : " << nivel_maximo;
        cout << endl;
        cout << endl;
        cout << "------------------------------------------------------- " <<endl;
        cout << endl;
        cout << endl << "Digite a Opcao (S:Sair, M:Menu): ";
        break;

      case 'M':
        menu();
        break;

      case 'S':
        return 0;
    }
  }
}
